---
stages:
  - lint
  - build-package

shellcheck:
  image: koalaman/shellcheck-alpine:stable
  stage: lint
  script:
    - shellcheck preseed-creator

build:
  image: hatsoftwares/preseed-creator-build:latest
  stage: build-package
  before_script:
    - mkdir -p ~/.minisign
    - chmod 700 ~/.minisign
    - "echo 'untrusted comment: minisign encrypted secret key' \
          > ~/.minisign/minisign.key"
    - echo $MINISIG_KEY >> ~/.minisign/minisign.key
    - chmod 600 ~/.minisign/minisign.key
  script:
    - make deb
    - mv preseed-creator.deb preseed-creator_${CI_COMMIT_TAG}.deb
    - echo $MINISIG_PWD | minisign -Sm preseed-creator_${CI_COMMIT_TAG}.deb
    - ls preseed-creator_${CI_COMMIT_TAG}.deb*
    - |
      curl --silent \
           --show-error \
           --user "$NC_USER:$NC_PWD" \
           --upload-file preseed-creator_${CI_COMMIT_TAG}.deb \
           "$NC_URL"
    - |
      curl --silent \
           --show-error \
           --user "$NC_USER:$NC_PWD" \
           --upload-file preseed-creator_${CI_COMMIT_TAG}.deb.minisig \
           "$NC_URL"
  needs:
    - shellcheck
  only:
    variables:
      - $MINISIG_KEY
      - $MINISIG_PWD
      - $NC_DL_URL
      - $NC_PWD
      - $NC_URL
      - $NC_USER
    refs:
      - tags
  release:
    tag_name: $CI_COMMIT_TAG
    name: $CI_COMMIT_TAG
    description: |
      ### Changelog

      `sed -n '/^'$CI_COMMIT_TAG'[[:space:]]/,/^[^\t]/p' CHANGELOG | sed -e 's/^[^\t].*//' -e 's/\t//g' | sed '/^[[:space:]]*$/d'`

      ### Installation

      Download the release and signature files, verify the signature and install the package:
      \`\`\`bash
      wget --quiet --content-disposition \
           "${NC_DL_URL}preseed-creator_${CI_COMMIT_TAG}.deb" \
           "${NC_DL_URL}preseed-creator_${CI_COMMIT_TAG}.deb.minisig" &&
        minisign -Vm preseed-creator_${CI_COMMIT_TAG}.deb -P RWQm7sZSguNVtitOiU4ozG+HgWWyUz4KmB0NMhjuTYkMardZlXjsKWLk &&
        sudo apt install ./preseed-creator_${CI_COMMIT_TAG}.deb
      \`\`\`
    assets:
      links:
        - name: 'Debian package'
          url: "${NC_DL_URL}preseed-creator_${CI_COMMIT_TAG}.deb"
          link_type: package
        - name: 'Minisign signature of the debian package'
          url: "${NC_DL_URL}preseed-creator_${CI_COMMIT_TAG}.deb.minisig"
          link_type: other
